import { select, json, geoPath, geoNaturalEarth1 } from 'd3';
import { feature } from 'topojson';

// Selects the SVG from the HTML
const svg = select('svg');

// Create a new geoNaturalEarth1() object for generating and projecting paths
const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

// Fetches the data from the end point and then formats it project on the canvas.
json('https://gist.githubusercontent.com/Gayathri-25/3a773d045557a08f6b916abb08e5d483/raw/651de35e51282bcaeaaa954294a6988704e0dc70/worlddata.csv')
  .then(data => {
  	// Extracts the all the countries from the data
    const countries = feature(data, data.objects.countries);
  	// Passes the extracted countries as data for generating the paths on the canvas
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });